'use strict'

const co = require('co')
const argx = require('argx')
const runApp = require('./apping/run_app')
const listApps = require('./apping/list_apps')
const apemanfile = require('apemanfile')

/** @lends apemanApp */
function apemanApp (name, options) {
  let args = argx(arguments)
  options = args.pop('object') || {}
  name = args.remain()
    .reduce((a, b) => [].concat(a, b), [])
    .filter((name) => !!name)

  let configuration = apemanfile(options.configuration)
  let here = process.cwd()
  let cwd = configuration.$cwd || process.cwd()

  return co(function * () {
    process.chdir(cwd)
    let result
    if (name.length > 0) {
      let { log, port, setup } = options
      result = yield runApp(configuration, name, {
        log, port, setup
      })
    } else {
      result = yield listApps(configuration)
    }

    process.chdir(here)

    return result
  })
}

module.exports = apemanApp
