/**
 * @function appEndpoints
 */

'use strict'

let concat = (a, b) => [].concat(a, b)

/** @lends appEndpoints */
function appEndpoints (apps) {
  return [].concat(apps).map((app) =>
    Object.keys(app || {}).map((pathname) =>
      [].concat(app[ pathname ] || [])
        .map((handler) => appEndpoints.createEndpoint(pathname, handler, app))
        .reduce(concat, [])
    ).reduce(concat, [])
  ).reduce(concat, [])
}

Object.assign(appEndpoints, {
  createEndpoint (pathname, handler, app) {
    if (typeof handler === 'string') {
      handler = require(handler)
      // Normalize babel compiled
      handler = handler.default || handler
    }
    return [].concat(handler).map((handler) => ({ pathname, handler }))
  }
})

module.exports = appEndpoints
