/**
 * Test case for runApp.
 * Runs with mocha.
 */
'use strict'

const runApp = require('../lib/apping/run_app.js')
const assert = require('assert')
const http = require('http')
const co = require('co')
const injectmock = require('injectmock')

describe('run-app', () => {
  before(() => co(function * () {
  }))

  after(() => co(function * () {
    injectmock.restoreAll()
  }))

  function _mockGet () {
    return ({
      '/': [
        function () {

        }
      ]
    })
  }

  it('Run app', () => co(function * () {
    let apemanfile = {
      get: _mockGet
    }
    assert.ok(apemanfile)
    let server = yield runApp(apemanfile, [
      'my-testing-app'
    ], {
      port: 3421
    })
    yield server.close()
  }))

  it('Start server.', () => co(function * () {
    injectmock(http, 'createServer', () => (
      {
        close (callback) {
          callback()
        },
        listen () {
        }
      })
    )
    let server = yield runApp({
      get: _mockGet
    }, [ 'foo' ])
    yield server.close()
  }))
})

/* global describe, before, after, it */
